#ifndef HARKTOOL4_FUNCTIONOBJECTS_HPP
#define HARKTOOL4_FUNCTIONOBJECTS_HPP

namespace harktool4
{

template <typename T>
class AssignConstant
{
    const T val_;

public:
    AssignConstant(const T& val)
        : val_(val)
    {}

    void operator ()(T& item) const
    {
        item = val_;
    }
};

template <typename Function>
class InplaceFunctor
{
    Function f_;

public:
    InplaceFunctor(Function f)
        : f_(f)
    {}

    template <typename T>
    void operator ()(T& item) const
    {
        item = f_(item);
    }
};

template <typename Function>
InplaceFunctor<Function> MakeInplaceFunctor(Function f)
{
    return InplaceFunctor<Function>(f);
}

}

#endif // HARKTOOL4_FUNCTIONOBJECTS_HPP
